import java.awt.*;
import java.io.*;

 class colortest extends Frame
{
static Frame f;
int reds[] = new int[256];
int greens[] = new int[256];
int blues[] = new int[256];
int newreds[] = new int[256];
TextArea T1 = new TextArea();
int x_offset=10;
int y_offset=220;
int x_picture_offset=10;
int y_picture_offset=60;
int picture_size=150;
int little_picture_size=15;
Color currentColor;
int currentColorInt;
int picture[][] = new int[15][15];
int brushsize=1, Tex_number, Tex_number_old;
boolean brush_repaint=true;
MenuBar mb;
Menu m1,m2;
MenuItem m1_new,m1_open,m1_save,m1_preview,m1_quit;
Graphics offGraphics;
Image offImage;
Dimension offDimension;

int tmp_x,tmp_y;
Color colors[] = new Color[256];

public colortest()
   {
   setTitle("Java Color Test (256 Color Palette)");
   setBackground (Color.lightGray);
//   setLayout(new BorderLayout());
setLayout(null);
mb = new MenuBar();
        setMenuBar(mb);
        
        m1 = new Menu("File");
        mb.add(m1);
        m1_new = new MenuItem("New");
        m1.add(m1_new);
        m1.addSeparator();
        m1_open = new MenuItem("Open");
        m1.add(m1_open);
        m1_save = new MenuItem("Save");
        m1.add(m1_save);
        m1.addSeparator();
        m1_preview = new MenuItem("Preview");
        m1.add(m1_preview);
        m1.addSeparator();
        m1_quit = new MenuItem("Quit");
        m1.add(m1_quit);


colorSet();
//add("Center",T1);
for(int i=0;i<256;i++)
{
colors[i] = new Color(reds[i],greens[i],blues[i]);
}

for (int i = 0;i<15;i++)
{
for (int j = 0;j<15;j++)
{
picture[i][j]=255;
}
}

currentColor = colors[0];
   }

public boolean action(Event evt, Object arg)      {

      if (arg.equals("Save"))
       {
       save();
       }else
      if(arg.equals("Preview"))
       {
       PreviewDialog PVD = new PreviewDialog(f,colors,picture);
       PVD.setVisible(true);
       } 
       
         return false;
}
  
public boolean mouseDrag(Event event, int x, int y)
   {
   Point point=null;
        if (point == null)
         {
             point = new Point(x,y);
         }
        point.x = x;
        point.y = y;
if ((x > (x_picture_offset)) && (x < (x_picture_offset+picture_size+1))&& (y > y_picture_offset) && (y < y_picture_offset+picture_size+1))
{        
int x_pixel = ((x-x_picture_offset)/10);
int y_pixel = ((y-y_picture_offset)/10);
if (x_pixel >14)
x_pixel=14;
if (y_pixel >14)
y_pixel=14;

//*
if (brushsize==1)
picture[x_pixel][y_pixel]=currentColorInt;
else
for(int i = 0;i<brushsize;i++)
{
for(int j = 0;j<brushsize;j++)
{
if((x_pixel+i<15)&&(y_pixel+j<15)){
picture[x_pixel+i][y_pixel+j]=currentColorInt;}
}
}
//*

//System.out.println("x: "+x_pixel+" y:"+y_pixel);
repaint();
}
return false;
}//end mousedrag

public boolean mouseDown(Event event, int x, int y)
   {
   Point point=null;
        if (point == null)
         {
             point = new Point(x,y);
         }
        point.x = x;
        point.y = y;
if ((x > (x_picture_offset)) && (x < (x_picture_offset+picture_size+1))&& (y > y_picture_offset) && (y < y_picture_offset+picture_size+1))
{        
int x_pixel = ((x-x_picture_offset)/10);
int y_pixel = ((y-y_picture_offset)/10);
//picture[x_pixel][y_pixel]=currentColorInt;
//*
if (brushsize==1)
picture[x_pixel][y_pixel]=currentColorInt;
else
for(int i = 0;i<brushsize;i++)
{
for(int j = 0;j<brushsize;j++)
{
if((x_pixel+i<15)&&(y_pixel+j<15)){
picture[x_pixel+i][y_pixel+j]=currentColorInt;}

}
}
//*
System.out.println("x: "+x_pixel+" y:"+y_pixel);
repaint();
}

if ((x > (x_offset-1)) && (x < (x_offset+(20*32)))&& (y > y_offset-1) && (y < y_offset+(20*8)))
{
if ((x < x_offset)||(y < y_offset))
{
x=0;
y=0;
}
        
        int x_coord = ((x-x_offset)/20);
        int y_coord = ((y-y_offset)/20);
//x 10 ... y 210     
if ((x_coord < 0)||(y_coord < 0))
{
x_coord=0;
y_coord=0;
}
Tex_number_old = Tex_number;
brush_repaint = true;
Tex_number = ((y_coord*32)+x_coord);
currentColor = colors[Tex_number];
currentColorInt=Tex_number;
System.out.println(x_coord+" >< "+y_coord+" Texture: "+Tex_number+"-old: "+Tex_number_old);

      repaint();
}
   return false;
   }

public boolean keyDown(Event e, int key)
           {
//System.out.println("test[1],[5]: "+map[1][5]);
//System.out.println("Key: "+key);

 
 if (key == 43) 
              {
if (brushsize ==15)
{}
else{
brushsize ++;
}
} 
 else
 if (key == 45) 
              {
if (brushsize == 1)
{}
   else{
brushsize -= 1;
   }
              } 

//  System.out.println("brushsize: "+brushsize);
brush_repaint=true;
repaint();
return false;
}



public void update(Graphics g)
{
  /*
Dimension d = size();

//Create the offscreen graphics context, if no good one exists.
        if ((offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height))
           { offDimension = d;
             offImage = createImage(d.width, d.height);
             offGraphics = offImage.getGraphics();
           }
        //Erase the previous image.
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(Color.lightGray);
*/
for (int i = 0;i<15;i++)
{
for (int j = 0;j<15;j++)
{
g.setColor(colors[picture[i][j]]);
g.fillRect(x_picture_offset+1+(i*10),y_picture_offset+1+(j*10),10,10);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+11+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;

/*
g.fillRect((x_picture_offset)+picture_size+100+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+115+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+130+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+145+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+160+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+175+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;

g.fillRect((x_picture_offset)+picture_size+100+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+115+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+130+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+145+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+160+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
g.fillRect((x_picture_offset)+picture_size+175+i,y_picture_offset+15+j,1,1);//picture[i][j]=255;
*/
//(x_picture_offset)+picture_size+10,y_picture_offset,little_picture_size+1,little_picture_size+1
}
}

g.setColor(Color.black);
g.drawRect(x_picture_offset,y_picture_offset,picture_size+1,picture_size+1);
g.drawRect((x_picture_offset)+picture_size+10,y_picture_offset,little_picture_size+1,little_picture_size+1);

if (brush_repaint)
{
g.setColor(Color.lightGray);
g.fillRect((x_picture_offset)+picture_size+35,y_offset-25,300,20);
//g.drawString("Brushsize: "+(brushsize+1)+"     Texture Number: "+Tex_number_old,(x_picture_offset)+picture_size+35,y_offset-15);
//g.drawString("Brushsize: "+(brushsize-1)+"     Texture Number: "+Tex_number_old,(x_picture_offset)+picture_size+35,y_offset-15);          //REMED 12/13/1999
g.setColor(Color.black);
}

brush_repaint=false;
g.drawString("Brushsize: "+brushsize+"     Color Number: "+Tex_number,(x_picture_offset)+picture_size+35,y_offset-15);
g.drawRect((x_picture_offset)+picture_size+10,y_offset-30,20,20);
g.setColor(currentColor);
g.fillRect((x_picture_offset)+picture_size+11,y_offset-29,19,19);


for(int j=0;j<8;j++)
{
for(int i=0;i<32;i++)
{
//System.out.println("Reds[]: "+reds[(j*32)+i]+" Greens[]: "+greens[i]+" Blues[]: "+blues[i]);
g.setColor(colors[(j*32)+i]);
g.fillRect(x_offset+(i*20),y_offset+(j*20),19,19);
}
}//end for j

//g.drawImage(offImage, 0, 0, this);
}

public void paint(Graphics g)
{
update(g);
}

public void save()
{
String filename;
FileDialog fdialog = new FileDialog(this,"Save File",FileDialog.SAVE);    
       fdialog.setFile("*.bmp");
       fdialog.show();
     if((filename = fdialog.getFile()) !=null)
       {
       filename = fdialog.getDirectory()+fdialog.getFile();
       }


try{
byte[] bits = new byte[1535];
FileInputStream Fin = new FileInputStream("JavaPixel.bmp");
Fin.read(bits,0,1077);
System.out.println("bits in");
   for(int i=0;i<240;i++)
      {
for(int q=0;q<15;q++)
{
for(int w=0;w<15;w++)
{
 //   bits[i+1078] = (byte)picture[q][w];
//Integer IT = new Integer(picture[w][q]);
bits[i+1078] = new Integer(picture[w][14-q]).byteValue();
//System.out.println(""+picture[w]);
i++;
}
////////////////////////////////////
i++;
bits[i+1078] = (byte)0;
/////////////////////////////////////
}//end for q
      }
System.out.println("bits2 in");

/*
//System.out.print("-");
for (int i=0;i<15;i++)
{
for (int j=0;j<15;j++)
{
//System.out.print((byte)(new Integer(picture[i][j])));
}
System.out.print("\n");
}
//*
 */


 for(int iii=0;iii<216;iii++)

      {
     bits[iii+1319] = (byte)0;

      }
System.out.println("bits3 in");
Fin.close();
FileOutputStream Fout = new FileOutputStream(filename);
Fout.write(bits);
Fout.close();
System.out.println("BMP256-out");
}
catch(IOException ee)
{System.out.println("*BMP256*: "+ee);}

}



public void colorSet()
{
int count;

//**************** Start Red ***************
//count=0;
for(int i =0;i<256;i++)
{
//if (count==32)
//{count=0;}

if ((i>-1)&&(i<32))
{
reds[i]=0;
//count++;
}
else
if ((i>31)&&(i<64))
{
reds[i]=32;
//count++;
}
else
if ((i>63)&&(i<96))
{
reds[i]=64;
//count++;
}
else
if ((i>95)&&(i<128))
{
reds[i]=96;
//count++;
} else
if ((i>127)&&(i<160))
{
reds[i]=128;
//count++;
}
else
if ((i>159)&&(i<192))
{
reds[i]=160;
//count++;
}
else
if ((i>191)&&(i<224))
{
reds[i]=192;
//count++;
}
else
if (i>223)
{
reds[i]=255;
//count++;
}


}
//**************** End Red *****************

//**************** Start Green ***************
count=0;
for(int i =0;i<256;i++)
{
if (count==32)
{count=0;}

if ((count>-1)&&(count<4))
{
greens[i]=0;
count++;
}
else
if ((count>3)&&(count<8))
{
greens[i]=32;
count++;
}
else
if ((count>7)&&(count<12))
{
greens[i]=64;
count++;
}
else
if ((count>11)&&(count<16))
{
greens[i]=96;
count++;
} else
if ((count>15)&&(count<20))
{
greens[i]=128;
count++;
}
else
if ((count>19)&&(count<24))
{
greens[i]=160;
count++;
}
else
if ((count>23)&&(count<28))
{
greens[i]=192;
count++;
}
else
if ((count>27)&&(count<32))
{
greens[i]=255;
count++;
}


}
//**************** End Green *****************



//**************** Start BLUE ***************
count=0;
for(int i =0;i<256;i++)
{
if (count==0)
{
blues[i]=0;
count++;
}
else
if (count==1)
{
blues[i]=64;
count++;
}
else
if (count==2)
{
blues[i]=128;
count++;
}
else
if (count==3)
{
blues[i]=255;
count=0;
}
}
//**************** End BLUE *****************

}

public boolean handleEvent(Event e)
   {
   if (e.id == Event.WINDOW_DESTROY)
      {
         System.exit(0);
      }
      return super.handleEvent(e);
   }

public static void main(String[] args)
   {
      f = new colortest();
      f.setSize(665,390);
      f.setVisible(true);
   }
}
